#ifndef VIS_INCLUDED

#define VIS_INCLUDED


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include <windows.h>


#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, V_PACK, 1)

typedef int (CALLBACK * VIS_GETSAMPLESPROC) (DWORD dwHandle, LPVOID lpvBuffer, DWORD dwSamples);

typedef int (WINAPI * VIS_INITIALIZE) (HWND hwndOwner, VIS_GETSAMPLESPROC GetSamplesProc);
typedef int (WINAPI * VIS_UNINITIALIZE) (void);
typedef int (WINAPI * VIS_OPENSOUND) (DWORD dwHandle, LPCSTR lpcszFileName, BOOL fIsFloat, DWORD dwBitsPerSample, DWORD dwSamplerate, DWORD dwChannels, __int64 TotalTime);
typedef int (WINAPI * VIS_CLOSESOUND) (DWORD dwHandle);
typedef int (WINAPI * VIS_PROCESS) (DWORD dwHandle, __int64 CurrentTime);
typedef HWND (WINAPI * VIS_SHOWPROPERTY) (HWND hwndOwner);

struct VIS_INTERFACE1
{
	VIS_INITIALIZE Initialize;
	VIS_UNINITIALIZE Uninitialize;
	VIS_OPENSOUND OpenSound;
	VIS_CLOSESOUND CloseSound;
	VIS_PROCESS Process;
	VIS_SHOWPROPERTY ShowProperty;
};

struct VIS_PLUGIN_INFO
{
	DWORD dwVersion;			//  o[Wԍ
	LPCSTR lpcszLibraryName;	//  Cu
	LPCSTR lpcszAuthorName;		//  Җ
	LPCSTR lpcszDescription;	//  ̑
	LPCSTR lpcszURL;			//  URL

	union
	{
		VIS_INTERFACE1 Interface1;
	};
};
typedef VIS_PLUGIN_INFO * LPVIS_PLUGIN_INFO;
typedef const VIS_PLUGIN_INFO * LPCVIS_PLUGIN_INFO;

typedef int (WINAPI * VISGETPLUGININFO) (LPCVIS_PLUGIN_INFO lpInfo);

#define GPPHDR_VER 0x10

// ^O
typedef struct{
	char pszArtist[256];
	char pszAlbum[256];
	char pszTitle[256];
	char pszTrack[10];
}TAGINFO;

#pragma pack(pop, V_PACK)

#ifdef __cplusplus
}
#endif



#endif	//  #ifndef VIS_INCLUDED
